Index: trunk/zoo-kernel/configure.ac
===================================================================
--- trunk/zoo-kernel/configure.ac	(revision 8)
+++ trunk/zoo-kernel/configure.ac	(revision 9)
@@ -298,6 +298,6 @@
 	LIBS="$JAVA_LDFLAGS"
 	# Shouldn't we get java here rather than java5 :) ??
-	AC_CHECK_LIB([javaplugin_jni], [JNI_CreateJavaVM], [], [AC_MSG_ERROR([could not find libjava])], [])
-	AC_CHECK_LIB([jvm], [main], [], [AC_MSG_ERROR([could not find libjava])], [])
+	AC_CHECK_LIB([jvm], [JNI_CreateJavaVM], [], [AC_MSG_ERROR([could not find libjava])], [])
+	#AC_CHECK_LIB([jvm], [main], [], [AC_MSG_ERROR([could not find libjava])], [])
 
 	AC_SUBST([JAVA_CPPFLAGS])
@@ -347,5 +347,4 @@
 	fi
 	
-
 	CPPFLAGS_SAVE="$CPPFLAGS"
         CPPFLAGS="$JS_CPPFLAGS"
@@ -367,5 +366,5 @@
 		JS_ENABLED="-DUSE_JS"
         	JS_FILE="service_internal_js.o"
-		JS_CPPFLAGS="-I$JSHOME/include"
+		JS_CPPFLAGS="-I$JSHOME/include/js"
                 JS_LDFLAGS="-L$JSHOME/lib -ljs -lm"
                 JS_LIB="js"
Index: trunk/zoo-kernel/main_conf_read.l
===================================================================
--- trunk/zoo-kernel/main_conf_read.l	(revision 8)
+++ trunk/zoo-kernel/main_conf_read.l	(revision 9)
@@ -1,5 +1,4 @@
 /* pour pouvoir acceder au numero de ligne dans bison */
 %option yylineno
-
 
 %{
@@ -114,9 +113,9 @@
 {newline}+{whitesp}*			{if (affichetrace==1) printf ("\n\nNEWLINE 1\n") ; return NEWLINE;}
 
-<INITIAL,HORSBALISE>"["{attname}"]"             {if (affichetrace==1) printf ("\n\nANID:%s\n",yytext); crlval.chaine=strdup(yytext);crlval.chaine[strlen(crlval.chaine)-1]=0;crlval.chaine+=1;return ANID; }
+<INITIAL,HORSBALISE>"["{attname}"]"             {if (affichetrace==1) printf ("\n\nANID:%s\n",yytext); crlval.chaine=yytext;crlval.chaine[strlen(crlval.chaine)-1]=0;crlval.chaine+=1;return ANID; }
 
-<INITIAL,HORSBALISE>{attname}             {if (affichetrace==1) printf ("\n\nATT_NAME:%s\n",yytext); crlval.chaine=strdup(yytext); return SPAIR; }
+<INITIAL,HORSBALISE>{attname}             {if (affichetrace==1) printf ("\n\nATT_NAME:%s\n",yytext); crlval.chaine=yytext; return SPAIR; }
 
-<PAIRSTART,HORSBALISE>{attvalue1}             {if (affichetrace==1) printf ("\n\nATT_VALUE:%s\n",yytext);crlval.chaine=strdup(yytext);BEGIN(INITIAL);return EPAIR;}
+<PAIRSTART,HORSBALISE>{attvalue1}             {if (affichetrace==1) printf ("\n\nATT_VALUE:%s\n",yytext);crlval.chaine=yytext;BEGIN(INITIAL);return EPAIR;}
 
 <PAIRSTART,INITIAL,HORSBALISE>{whitesp}*"="{whitesp}*             {BEGIN(PAIRSTART);}
@@ -161,5 +160,5 @@
 
 
-<DANSBALISE>{Name}			{if (affichetrace==1) printf ("\n\nID:%s\n",yytext) ; crlval.s=strdup(yytext);return ID;}
+<DANSBALISE>{Name}			{if (affichetrace==1) printf ("\n\nID:%s\n",yytext) ; crlval.s=yytext;return ID;}
 
 
@@ -175,4 +174,4 @@
 
 
-int yywrap()
+int crwrap()
 {return 1;}
Index: trunk/zoo-kernel/main_conf_read.y
===================================================================
--- trunk/zoo-kernel/main_conf_read.y	(revision 8)
+++ trunk/zoo-kernel/main_conf_read.y	(revision 9)
@@ -5,6 +5,4 @@
 **/
 //======================================================
-
-
 
 #include <string>
@@ -23,9 +21,6 @@
 static char* curr_key;
 static int debug=0;
-//static int data=-1;
 static int previous_data=0;
 static int current_data=0;
-//static char* myFinalObjectAsJSON="{";
-// namespace
 using namespace std;
 
@@ -43,5 +38,5 @@
 
 extern int crlex(void);
-
+extern int crlex_destroy(void);
 
 %}
@@ -128,16 +123,16 @@
  : STag contentetoile ETag	
 {
-	/* les non terminaux rendent les valeurs de leur identifiants de balise */
-	/* en char*, donc on peut comparer ces valeurs avec la fonction C++ strcmp(const char*;const char*) */
-	/* de string */
-	if (strcmp($1,$3) != 0)
-	{
-	   crerror("Opening and ending tag mismatch");
-	   printf("\n  ::details : tag '%s' et '%s' \n",$1,$3);
-	   return 1;
-	   // on retourne different de 0
-	   // sinon yyparse rendra 0
-	   // et dans le main on croira a le fichier xml est valide !
-	}
+  /* les non terminaux rendent les valeurs de leur identifiants de balise */
+  /* en char*, donc on peut comparer ces valeurs avec la fonction C++ strcmp(const char*;const char*) */
+  /* de string */
+  if (strcmp($1,$3) != 0)
+    {
+      crerror("Opening and ending tag mismatch");
+      printf("\n  ::details : tag '%s' et '%s' \n",$1,$3);
+      return 1;
+      // on retourne different de 0
+      // sinon yyparse rendra 0
+      // et dans le main on croira a le fichier xml est valide !
+    }
 }
 // pour neutre
@@ -266,6 +261,7 @@
   if(current_content==NULL) 
     current_content=createMap(curr_key,$1);
-  else 
+  else{ 
     addToMap(current_content,curr_key,$1);
+  }
   if(debug){ 
     printf("EPAIR FOUND !! \n"); 
@@ -279,15 +275,24 @@
 
 processid
- : ANID  {
+: ANID  {
    if(current_maps->name!=NULL){
-     current_maps->content=current_content;
-     current_maps->next=(maps*)malloc(MAP_SIZE);
+     addMapToMap(&current_maps->content,current_content);
+     freeMap(&current_content);
+     free(current_content);
+     current_maps->next=NULL;
+     current_maps->next=(maps*)malloc(MAPS_SIZE);
+     current_maps->next->name=strdup($1);
+     current_maps->next->content=NULL;
+     current_maps->next->next=NULL;
      current_maps=current_maps->next;
-     current_maps->name=strdup($1);
+     current_content=current_maps->content;
+   }
+   else{
+     current_maps->name=(char*)malloc((strlen($1)+1)*sizeof(char));
+     snprintf(current_maps->name,(strlen($1)+1),"%s",$1);
+     current_maps->content=NULL;
+     current_maps->next=NULL;
      current_content=NULL;
    }
-   else{
-     current_maps->name=strdup($1);
-   }
  }
  ;
@@ -310,7 +315,4 @@
 //======================================================
 int conf_read(char* file,maps* my_map){
-  /* mode debug ou pas : */
-  /* 1 = debug , 0 = normal */
-  //yydebug = 1;
   
   crin = fopen(file,"r");
@@ -320,5 +322,4 @@
   }
 
-  //my_map=(maps*)malloc(sizeof(maps*));
   my_maps=my_map;
   my_maps->name=NULL;
@@ -326,19 +327,18 @@
   
   int resultatYYParse = crparse() ;
-
-  if(current_content!=NULL)
-    current_maps->content=current_content;
-	  
-  //dumpMaps(my_maps);
+  if(current_content!=NULL){
+    addMapToMap(&current_maps->content,current_content);
+    current_maps->next=NULL;
+    freeMap(&current_content);
+    free(current_content);
+  }
 
   fclose(crin);
+  crlex_destroy();
+
   return resultatYYParse;
 }
 
 
-void usage(void)
-{
-    printf("usage : $./test1 <fichier_de_configuration_principale>\n") ;	 
-}
 //======================================================
 // FIN //
Index: trunk/zoo-kernel/service.h
===================================================================
--- trunk/zoo-kernel/service.h	(revision 8)
+++ trunk/zoo-kernel/service.h	(revision 9)
@@ -40,4 +40,5 @@
 #define true 1
 #define false -1
+
 #define SERVICE_ACCEPTED 0
 #define SERVICE_STARTED 1
@@ -45,10 +46,13 @@
 #define SERVICE_SUCCEEDED 3
 #define SERVICE_FAILED 4
+
 #define ELEMENTS_SIZE (sizeof(char*)+(((2*sizeof(char*))+sizeof(maps*))*2)+sizeof(char*)+(((2*sizeof(char*))+sizeof(iotype*))*2)+sizeof(elements*))
-#define MAP_SIZE (2*sizeof(char*))+sizeof(map*)
-#define MAPS_SIZE (2*sizeof(char*))+sizeof(map*)+sizeof(maps*)
-
-
-  static char* mtoupper(char* str){
+#define MAP_SIZE (2*sizeof(char*))+sizeof(NULL)
+#define IOTYPE_SIZE MAP_SIZE+sizeof(NULL)
+#define MAPS_SIZE (2*sizeof(char*))+sizeof(map*)+MAP_SIZE
+#define SERVICE_SIZE (ELEMENTS_SIZE*2)+(MAP_SIZE*2)+sizeof(char*)
+
+
+  /*  static char* mtoupper(char* str){
     char* tmp=strdup(str);
     if(tmp){
@@ -63,16 +67,28 @@
       tmp[0]=0;
     return tmp;
-  }
-
+    }*/
+
+  /**
+   * \struct maps
+   * \brief linked list of map pointer
+   *
+   * Small object to store WPS KVP set.
+   */
   typedef struct maps{
-    char* name;
-    struct map* content;
-    struct maps* next;
+    char* name;          
+    struct map* content; 
+    struct maps* next;   
   } maps;
 
+  /**
+   * \struct map
+   * \brief KVP linked list
+   *
+   * Deal with WPS KVP (name,value).
+   */
   typedef struct map{
-    char* name;
-    char* value;
-    struct map* next;
+    char* name;       /* The key */
+    char* value;      /* The value */
+    struct map* next; /* Next couple */
   } map;
 
@@ -83,5 +99,5 @@
 #endif
 
-  static void* _dumpMap(map* t){
+  static void _dumpMap(map* t){
     if(t!=NULL){
       fprintf(stderr,"[%s] => [%s] \n",t->name,t->value);
@@ -91,8 +107,7 @@
       fflush(stderr);
     }
-    return NULL;
-  }
-
-  static void* dumpMap(map* t){
+  }
+
+  static void dumpMap(map* t){
     map* tmp=t;
     while(tmp!=NULL){
@@ -100,5 +115,4 @@
       tmp=tmp->next;
     }
-    return NULL;
   }
 
@@ -112,5 +126,5 @@
   }
 
-  static map* createMap(char* name,char* value){
+  static map* createMap(const char* name,const char* value){
     map* tmp=(map *)malloc(MAP_SIZE);
     tmp->name=strdup(name);
@@ -130,8 +144,8 @@
   }
     
-  static bool hasKey(map* m,char *key){
+  static bool hasKey(map* m,const char *key){
     map* tmp=m;
     while(tmp!=NULL){
-      if(strcmp(mtoupper(tmp->name),mtoupper(key))==0)
+      if(strncasecmp(tmp->name,key,strlen(key))==0)
 	return true;
       tmp=tmp->next;
@@ -143,9 +157,10 @@
   }
 
-  static maps* getMaps(maps* m,char *key){
+  static maps* getMaps(maps* m,const char *key){
     maps* tmp=m;
     while(tmp!=NULL){
-      if(strcmp(mtoupper(tmp->name),mtoupper(key))==0)
+      if(strncasecmp(tmp->name,key,strlen(key))==0){
 	return tmp;
+      }
       tmp=tmp->next;
     }
@@ -153,9 +168,10 @@
   }
 
-  static map* getMap(map* m,char *key){
+  static map* getMap(map* m,const char *key){
     map* tmp=m;
     while(tmp!=NULL){
-      if(strcmp(mtoupper(tmp->name),mtoupper(key))==0)
+      if(strncasecmp(tmp->name,key,strlen(key))==0){
 	return tmp;
+      }
       tmp=tmp->next;
     }
@@ -166,13 +182,16 @@
     maps* _tmpm=getMaps(m,key);
     if(_tmpm!=NULL){
-      map* tmpm=getMap(_tmpm->content,mtoupper(subkey));
-      return tmpm;
+      map* _ztmpm=getMap(_tmpm->content,subkey);
+      return _ztmpm;
     }
     else return NULL;
   }
 
-  static void* freeMap(map** mo){
+  static void freeMap(map** mo){
     map* _cursor=*mo;
     if(_cursor!=NULL){
+#ifdef DEBUG
+      fprintf(stderr,"freeMap\n");
+#endif
       free(_cursor->name);
       free(_cursor->value);
@@ -182,7 +201,24 @@
       }
     }
-	return NULL;
-  }
-
+  }
+
+  static void freeMaps(maps** mo){
+    maps* _cursor=*mo;
+    fflush(stderr);
+    if(_cursor && _cursor!=NULL){
+#ifdef DEBUG
+      fprintf(stderr,"freeMaps\n");
+#endif
+      free(_cursor->name);
+      if(_cursor->content!=NULL){
+      	freeMap(&_cursor->content);
+      	free(_cursor->content);
+      }
+      if(_cursor->next!=NULL){
+	freeMaps(&_cursor->next);
+	free(_cursor->next);
+      }
+    }
+  }
 
   typedef struct iotype{
@@ -217,7 +253,5 @@
     elements* tmp=e;
     while(tmp!=NULL){
-      mtoupper(key);
-      mtoupper(tmp->name);
-      if(strcmp(key,tmp->name)==0)
+      if(strncasecmp(key,tmp->name,strlen(key))==0)
 	return true;
       tmp=tmp->next;
@@ -229,7 +263,5 @@
     elements* tmp=m;
     while(tmp!=NULL){
-      mtoupper(tmp->name);
-      mtoupper(key);
-      if(strcmp(tmp->name,key)==0)
+      if(strncasecmp(tmp->name,key,strlen(tmp->name))==0)
 	return tmp;
       tmp=tmp->next;
@@ -239,13 +271,14 @@
 
 
-  static void* freeIOType(iotype** i){
+  static void freeIOType(iotype** i){
     iotype* _cursor=*i;
     if(_cursor!=NULL){
       freeMap(&_cursor->content);
       free(_cursor->content);
-      freeIOType(&_cursor->next);
-      free(_cursor->next);
-    }
-	return NULL;
+      if(_cursor->next!=NULL){
+	freeIOType(&_cursor->next);
+	free(_cursor->next);
+      }
+    }
   }
 
@@ -253,41 +286,25 @@
     elements* tmp=*e;
     if(tmp!=NULL){
-#ifdef DEBUG
-      fprintf(stderr,"FREE 1");
-#endif
       free(tmp->name);
       freeMap(&tmp->content);
-#ifdef DEBUG
-      fprintf(stderr,"FREE 2");
-#endif
       free(tmp->content);
       freeMap(&tmp->metadata);
-#ifdef DEBUG
-      fprintf(stderr,"FREE 3");
-#endif
       free(tmp->metadata);
-#ifdef DEBUG
-      fprintf(stderr,"FREE 4");
-#endif
       free(tmp->format);
       freeIOType(&tmp->defaults);
-#ifdef DEBUG
-      fprintf(stderr,"FREE 5");
-#endif
       if(tmp->defaults!=NULL)
 	free(tmp->defaults);
       freeIOType(&tmp->supported);
-#ifdef DEBUG
-      fprintf(stderr,"FREE 6");
-#endif
       if(tmp->supported!=NULL)
 	free(tmp->supported);
-      tmp=tmp->next;
-    }
-  }
-
-  static void* freeService(service** s){
+      freeElements(&tmp->next);
+    }
+  }
+
+  static void freeService(service** s){
     service* tmp=*s;
     if(tmp!=NULL){
+      if(tmp->name!=NULL)
+	free(tmp->name);
       freeMap(&tmp->content);
       if(tmp->content!=NULL)
@@ -305,58 +322,5 @@
   }
 
-  static void* addMapToMap(map** mo,map* mi){
-    map* tmp=mi;
-    map* _cursor=*mo;
-    while(tmp!=NULL){
-      if(_cursor==NULL){
-	*mo=(map*)malloc(MAP_SIZE);
-	*mo=createMap(tmp->name,tmp->value);
-	_cursor=*mo;
-	_cursor->next=NULL;
-      }
-      else{
-	while(_cursor->next!=NULL)
-	  _cursor=_cursor->next;
-	_cursor->next=createMap(tmp->name,tmp->value);
-      }
-      tmp=tmp->next;
-    }
-    return NULL;
-  }
-
-  static void* addMapsToMaps(maps** mo,maps* mi){
-    maps* tmp=mi;
-    maps* _cursor=*mo;
-    while(tmp!=NULL){
-      if(_cursor==NULL){
-	*mo=(maps*)malloc(MAP_SIZE);
-	*mo=mi;
-	_cursor=*mo;
-      }
-      else{
-	while(_cursor->next!=NULL)
-	  _cursor=_cursor->next;
-	_cursor->next=tmp;
-      }
-      tmp=tmp->next;
-    }
-    return NULL;
-  }
-
-  static void* addMapToIotype(iotype** io,map* mi){
-    iotype* tmp=*io;
-    while(tmp!=NULL){
-      fprintf(stderr,">> CURRENT MAP");
-      dumpMap(tmp->content);
-      tmp=tmp->next;
-    }
-    tmp=(iotype*)malloc(ELEMENTS_SIZE);
-    tmp->content=NULL;
-    tmp->next=NULL;
-    addMapToMap(&tmp->content,mi);
-    return NULL;
-  }
-
-  static void* addToMap(map* m,char* n,char* v){
+  static void addToMap(map* m,const char* n,const char* v){
     if(hasKey(m,n)==false){
       map* _cursor=m;
@@ -367,11 +331,115 @@
     else{
       map *tmp=getMap(m,n);
+      if(tmp->value!=NULL)
+      	free(tmp->value);
       tmp->value=strdup(v);
     }
-    return NULL;
-  }
-
-
-  static void* dumpElements(elements* e){
+  }
+
+  static void addMapToMap(map** mo,map* mi){
+    map* tmp=mi;
+    map* _cursor=*mo;
+    if(tmp==NULL){
+      if(_cursor!=NULL){
+	while(_cursor!=NULL)
+	  _cursor=_cursor->next;
+	_cursor=NULL;
+      }else
+	*mo=NULL;
+    }
+    while(tmp!=NULL){
+      if(_cursor==NULL){
+	if(*mo==NULL)
+	  *mo=createMap(tmp->name,tmp->value);
+	else
+	  addToMap(*mo,tmp->name,tmp->value);
+      }
+      else{
+#ifdef DEBUG
+	fprintf(stderr,"_CURSOR\n");
+	dumpMap(_cursor);
+#endif
+	while(_cursor!=NULL)
+	  _cursor=_cursor->next;
+	_cursor=createMap(tmp->name,tmp->value);
+	_cursor->next=NULL;
+      }
+      tmp=tmp->next;
+#ifdef DEBUG
+      fprintf(stderr,"MO\n");
+      dumpMap(*mo);
+#endif
+    }
+  }
+
+  static void addMapToIoType(iotype** io,map* mi){
+    iotype* tmp=*io;
+    while(tmp!=NULL){
+#ifdef DEBUG
+      fprintf(stderr,">> CURRENT MAP");
+      dumpMap(tmp->content);
+#endif
+      tmp=tmp->next;
+    }
+#ifdef DEBUG
+    fprintf(stderr,">> %s %i\n",__FILE__,__LINE__);
+    fflush(stderr);
+#endif
+    tmp=(iotype*)malloc(IOTYPE_SIZE);
+#ifdef DEBUG
+    fprintf(stderr,">> %s %i\n",__FILE__,__LINE__);
+    fflush(stderr);
+#endif
+    tmp->content=NULL;
+#ifdef DEBUG
+    fprintf(stderr,">> %s %i\n",__FILE__,__LINE__);
+    fflush(stderr);
+#endif
+    addMapToMap(&tmp->content,mi);
+#ifdef DEBUG
+    fprintf(stderr,">> %s %i\n",__FILE__,__LINE__);
+    fflush(stderr);
+#endif
+    dumpMap(tmp->content);
+    tmp->next=NULL;
+  }
+
+
+  static maps* dupMaps(maps** mo){
+    maps* _cursor=*mo;
+    maps* res=NULL;
+    if(_cursor!=NULL){
+      res=(maps*)malloc(MAPS_SIZE);
+      res->name=strdup(_cursor->name);
+      res->content=NULL;
+      res->next=NULL;
+      map* mc=_cursor->content;
+      if(mc!=NULL){
+	addMapToMap(&res->content,mc);
+      }
+      res->next=dupMaps(&_cursor->next);
+    }
+    return res;
+  }
+
+  static void addMapsToMaps(maps** mo,maps* mi){
+    maps* tmp=mi;
+    maps* _cursor=*mo;
+    while(tmp!=NULL){
+      if(_cursor==NULL){
+	*mo=dupMaps(&mi);
+	(*mo)->next=NULL;
+      }
+      else{
+	while(_cursor->next!=NULL)
+	  _cursor=_cursor->next;
+	_cursor->next=dupMaps(&tmp);
+      }
+      tmp=tmp->next;
+    }
+  }
+
+
+  static void dumpElements(elements* e){
     elements* tmp=e;
     while(tmp!=NULL){
@@ -401,14 +469,16 @@
       tmp=tmp->next;
     }
-    return NULL;
-  }
-
+  }
 
   static elements* dupElements(elements* e){
-    if(e!=NULL){
-#ifdef DEBUG
+    elements* cursor=e;
+    elements* tmp=NULL;
+    if(cursor!=NULL){
+#ifdef DEBUG
+      fprintf(stderr,">> %s %i\n",__FILE__,__LINE__);
       dumpElements(e);
-#endif
-      elements* tmp=(elements*)malloc(ELEMENTS_SIZE);
+      fprintf(stderr,">> %s %i\n",__FILE__,__LINE__);
+#endif
+      tmp=(elements*)malloc(ELEMENTS_SIZE);
       tmp->name=strdup(e->name);
       tmp->content=NULL;
@@ -418,45 +488,54 @@
       tmp->format=strdup(e->format);
       if(e->defaults!=NULL){
-	tmp->defaults=(iotype*)malloc(MAP_SIZE);
+	tmp->defaults=(iotype*)malloc(IOTYPE_SIZE);
 	tmp->defaults->content=NULL;
+	addMapToMap(&tmp->defaults->content,e->defaults->content);
 	tmp->defaults->next=NULL;
-	addMapToMap(&tmp->defaults->content,e->defaults->content);
-	while(e->defaults->next!=NULL){
-	  tmp->defaults->next=(iotype*)malloc(MAP_SIZE);
-	  addMapToMap(&tmp->defaults->next->content,e->defaults->content);
-	}
-      }
+#ifdef DEBUG
+	fprintf(stderr,">> %s %i\n",__FILE__,__LINE__);
+	dumpMap(tmp->defaults->content);
+#endif
+      }else
+	tmp->defaults=NULL;
       if(e->supported!=NULL){
-	tmp->supported=(iotype*)malloc(MAP_SIZE);
+	tmp->supported=(iotype*)malloc(IOTYPE_SIZE);
 	tmp->supported->content=NULL;
 	tmp->supported->next=NULL;
 	addMapToMap(&tmp->supported->content,e->supported->content);
+	iotype *etmp=*(&tmp->supported->next) ;
 	iotype *tmp2=e->supported->next;
 	while(tmp2!=NULL){
-	  tmp->supported->next=(iotype*)malloc(MAP_SIZE);
-	  addMapToMap(&tmp->supported->next->content,tmp2->content);
+	  etmp=(iotype*)malloc(IOTYPE_SIZE);
+	  etmp->content=NULL;
+	  addMapToMap(&etmp->content,tmp2->content);
+	  etmp->next=NULL;
+#ifdef DEBUG
+	  fprintf(stderr,">> %s %i\n",__FILE__,__LINE__);
+	  dumpMap(tmp->defaults->content);
+#endif
 	  tmp2=tmp2->next;
+	  etmp=etmp->next;
 	}
       }
-      tmp->next=NULL;
-      return tmp;
-    }
-    return NULL;
-  }
-
-  static void* addToElements(elements* m,elements* e){
-    elements* _cursor=m;
+      else
+	tmp->supported=NULL;
+      tmp->next=dupElements(cursor->next);
+    }
+    return tmp;
+  }
+
+  static void addToElements(elements** m,elements* e){
+    elements* _cursor=*m;
     elements* tmp=e;
     if(_cursor==NULL){
-      m=dupElements(tmp);
-      return NULL;
-    }
-    while(_cursor->next!=NULL)
-      _cursor=_cursor->next;
-    _cursor->next=dupElements(tmp);
-    return NULL;
-  }
-
-  static void* dumpService(service* s){
+      *m=dupElements(tmp);
+    }else{
+      while(_cursor->next!=NULL)
+	_cursor=_cursor->next;
+      _cursor->next=dupElements(tmp);
+    }
+  }
+
+  static void dumpService(service* s){
     fprintf(stderr,"++++++++++++++++++\nSERVICE [%s]\n++++++++++++++++++\n",s->name);
     if(s->content!=NULL){
@@ -475,8 +554,7 @@
     }
     fprintf(stderr,"++++++++++++++++++\n");
-    return NULL;
-  }
-
-  static void* mapsToCharXXX(maps* m,char*** c){
+  }
+
+  static void mapsToCharXXX(maps* m,char*** c){
     maps* tm=m;
     int i=0;
@@ -506,8 +584,7 @@
     }
     memcpy(c,tmp,10*10*1024);
-	return NULL;
-  }
-
-  static void* charxxxToMaps(char*** c,maps**m){
+  }
+
+  static void charxxxToMaps(char*** c,maps**m){
     maps* trorf=*m;
     int i,j;
@@ -526,10 +603,9 @@
 	  trorf->content=createMap(tmp[i][j],tmp[i][j+1]);
 	else
-	addMapToMap(&trorf->content,createMap(tmp[i][j],tmp[i][j+1]));
+	  addToMap(trorf->content,tmp[i][j],tmp[i][j+1]);
       }
       trorf=trorf->next;
     }
     m=&trorf;
-    return NULL;
   }
 
Index: trunk/zoo-kernel/service_conf.l
===================================================================
--- trunk/zoo-kernel/service_conf.l	(revision 8)
+++ trunk/zoo-kernel/service_conf.l	(revision 9)
@@ -124,5 +124,5 @@
 /*====================================================*/
 attname	[a-zA-Z0-9_\-]+
-attvalue1	[a-zA-Z0-9_\-.:" "\"\'/\\\(\)]+
+attvalue1	[\*\+,;@a-zA-Z0-9_\-::.:" "\"\'/\\\(\)]+
 
 
@@ -159,55 +159,55 @@
 {newline}+{whitesp}*			{  if (affichetrace==1) fprintf (stderr,"\n\nNEWLINE 1\n") ; return NEWLINE;}
 
-<INITIAL,HORSBALISE>"["{attname}"]"             {  if (affichetrace==1){ fprintf (stderr,"\n\nANID:%s\n",yytext); fprintf(stderr,"[ZOO: service_conf.l line 161 srlval.chaine=strdup(%s), srlval.chaine=%s]\n",yytext,srlval.chaine);fflush(stderr);}srlval.chaine=strdup(yytext);srlval.chaine[strlen(srlval.chaine)-1]=0;srlval.chaine+=1;if (affichetrace==1){fprintf(stderr,"[ZOO: service_conf.l line 161 srlval.chaine=strdup(%s) done]\n",yytext);fflush(stderr);} return ANID; }
-
-<INITIAL,HORSBALISE>{attname}             {  if (affichetrace==1){fprintf (stderr,"\n\nATT_NAME:%s\n",yytext); fprintf(stderr,"[ZOO: service_conf.l line 163 srlval.chaine=strdup(%s)]\n",yytext);fflush(stderr);}srlval.chaine=strdup(yytext); if (affichetrace==1){fprintf(stderr,"[ZOO: service_conf.l line 163 srlval.chaine=strdup(%s) done]\n",yytext);fflush(stderr);} return SPAIR; }
-
-<PAIRSTART,HORSBALISE>{attvalue1}             { if (affichetrace==1){ fprintf (stderr,"\n\nATT_VALUE:%s\n",yytext);fprintf(stderr,"[ZOO: service_conf.l line 165 srlval.chaine=strdup(%s)]\n",yytext);fflush(stderr);}srlval.chaine=strdup(yytext);if (affichetrace==1){fprintf(stderr,"[ZOO: service_conf.l line 165 srlval.chaine=strdup(%s)]\n",yytext);fflush(stderr);BEGIN(INITIAL);} return EPAIR;}
+<INITIAL,HORSBALISE>"["{attname}"]"             {  srlval.chaine=yytext;return ANID; }
+
+<INITIAL,HORSBALISE>{attname}             {  srlval.chaine=yytext; return SPAIR; }
+
+<PAIRSTART,HORSBALISE>{attvalue1}             { srlval.chaine=yytext;/*BEGIN(INITIAL);*/ return EPAIR;}
 
 <PAIRSTART,INITIAL,HORSBALISE>{whitesp}*"="{whitesp}*             {  BEGIN(PAIRSTART);}
 
-<PAIRSTART,INITIAL,HORSBALISE,DANSBALISE>{newline}+{whitesp}*             { if (affichetrace==1) fprintf (stderr,"\n\nNEWLINE 2\n") ; BEGIN(INITIAL);  return NEWLINE;}
-
-<INITIAL>"<?"[Xx][Mm][Ll]  {   if (attentionImpossibleDeTrouverXMLDeclapres == 1 || attentionImpossibleDeTrouverPIapres == 1) {/* il y a eut un commentaire ou une balise applicative avant la declaration xml */ fprintf(stderr,"\nerror : a la ligne %d : il y a eut un commentaire ou un PI avant la declaration xml\n",srlineno); exit (10) ; } ; if (affichetrace==1) fprintf (stderr,"\n\nSTARTXMLDECL:%s\n",srtext) ;  return STARTXMLDECL;}
-
-<INITIAL>"version"{egalevolue}\"1.0\"|"version"{egalevolue}\'1.0\'  {  if (affichetrace==1) fprintf (stderr,"\n\nVERSIONDECL:%s\n",srtext) ;return VERSIONDECL;  }
+<PAIRSTART,INITIAL,HORSBALISE,DANSBALISE>{newline}+{whitesp}*             { BEGIN(INITIAL);  return NEWLINE;}
+
+<INITIAL>"<?"[Xx][Mm][Ll]  {   if (attentionImpossibleDeTrouverXMLDeclapres == 1 || attentionImpossibleDeTrouverPIapres == 1) {/* il y a eut un commentaire ou une balise applicative avant la declaration xml */ fprintf(stderr,"\nerror : a la ligne %d : il y a eut un commentaire ou un PI avant la declaration xml\n",srlineno); exit (10) ; } ; return STARTXMLDECL;}
+
+<INITIAL>"version"{egalevolue}\"1.0\"|"version"{egalevolue}\'1.0\'  { return VERSIONDECL;  }
 <INITIAL>"version"{egalevolue}\"[^"]*\"|"version"{egalevolue}\'[^']*\'  {/* erreur de version encoding */ fprintf(stderr,"\nerror : a la ligne %d : la version xml n est pas reconnue : %s\n",srlineno,yytext); exit (9) ; }
 
 
-<INITIAL>"encoding"{egalevolue}\"[Ii][Ss][Oo]"-8859-1"\"|"encoding"{egalevolue}\'[Ii][Ss][Oo]"-8859-1"\'  { if (affichetrace==1) fprintf (stderr,"\n\nENCODINGDECL:%s\n",yytext) ; return ENCODINGDECL;}
+<INITIAL>"encoding"{egalevolue}\"[Ii][Ss][Oo]"-8859-1"\"|"encoding"{egalevolue}\'[Ii][Ss][Oo]"-8859-1"\'  { return ENCODINGDECL;}
 <INITIAL>"encoding"{egalevolue}\"[^"]*\"|"encoding"{egalevolue}\'[^']*\'  {/* erreur de version encoding */ 	fprintf(stderr,"\nerror : a la ligne %d : la version d encodage n est pas reconnue : %s\n",srlineno,yytext); exit (8) ; }
 
 
-<INITIAL>"standalone"{egalevolue}\"yes\"|"standalone"{egalevolue}\'yes\'|"standalone"{egalevolue}\"no\"|"standalone"{egalevolue}\'no\'  { if (affichetrace==1) fprintf (stderr,"\n\nSDDECL:%s\n",yytext) ; return SDDECL;}
+<INITIAL>"standalone"{egalevolue}\"yes\"|"standalone"{egalevolue}\'yes\'|"standalone"{egalevolue}\"no\"|"standalone"{egalevolue}\'no\'  { return SDDECL;}
 
 <INITIAL>"standalone"{egalevolue}\"[^"]*\"|"standalone"{egalevolue}\'[^']*\'|"standalone"{egalevolue}\"[^"]*\"|"standalone"{egalevolue}\'[^']*\'  { /* erreur de version encoding */ 	fprintf(stderr,"\nerror : a la ligne %d : la version standalone n est pas reconnue : %s\n",srlineno,yytext); exit (7) ; }
 
 
-<INITIAL>"?>"  { if (affichetrace==1) fprintf (stderr,"\n\nENDXMLDECL:%s\n",yytext) ; BEGIN(HORSBALISE); return ENDXMLDECL;}
-
-
-<DANSBALISE,INITIAL,HORSBALISE>{S}   { if (affichetrace==1) fprintf (stderr,"\n\nS:'%s'\n",yytext) ; }
-
-
-<HORSBALISE>"<?"[Xx][Mm][Ll]{S}({S}|{chardata})*"?>"|"<?"[Xx][Mm][Ll]"?>"	{ if (affichetrace==1) fprintf (stderr,"\n\nPIERROR:%s\n",yytext) ; return PIERROR;}
-<INITIAL,HORSBALISE>"<?"([^xX]|([xX][^mM])|([xX][mM][^lL]))({S}|([^?]|("?"[^>])))*"?>"		{ attentionImpossibleDeTrouverPIapres=1 ;  if (affichetrace==1) fprintf (stderr,"\n\nPI:%s\n",yytext) ; return PI;}
-
-
-<INITIAL,HORSBALISE>{newline}*"<"		    { if (affichetrace==1) fprintf (stderr,"\n\nINFCAR:%s\n",yytext) ; BEGIN(DANSBALISE); return INFCAR;}
-
-
-<DANSBALISE>">"			{ if (affichetrace==1) fprintf (stderr,"\n\nSUPCAR:%s\n",yytext) ; BEGIN(HORSBALISE);return SUPCAR;}
-
-
-<DANSBALISE>"/"		{if (affichetrace==1) fprintf (stderr,"\n\nSLASH:%s\n",yytext) ; return SLASH;}
-
-
-<DANSBALISE>{egalevolue}			{if (affichetrace==1) fprintf (stderr,"\n\nEq:'%s'\n",yytext) ; return Eq;}
-
-
-<DANSBALISE>{Name}			{if (affichetrace==1){fprintf (stderr,"\n\nID:%s\n",yytext) ; fprintf(stderr,"[ZOO: service_conf.l line 208 srlval.chaine=strdup(%s)]\n",yytext);fflush(stderr);}srlval.s=strdup(yytext);if (affichetrace==1){fprintf(stderr,"[ZOO: service_conf.l line 208 srlval.chaine=strdup(%s)]\n",yytext);fflush(stderr);}return ID;}
-
-
-<DANSBALISE>{attvalue}		{if (affichetrace==1) fprintf (stderr,"\n\nATTVALUE:%s\n",yytext) ; return ATTVALUE;}
+<INITIAL>"?>"  { BEGIN(HORSBALISE); return ENDXMLDECL;}
+
+
+<DANSBALISE,INITIAL,HORSBALISE>{S}   {  }
+
+
+<HORSBALISE>"<?"[Xx][Mm][Ll]{S}({S}|{chardata})*"?>"|"<?"[Xx][Mm][Ll]"?>"	{ return PIERROR;}
+<INITIAL,HORSBALISE>"<?"([^xX]|([xX][^mM])|([xX][mM][^lL]))({S}|([^?]|("?"[^>])))*"?>"		{ attentionImpossibleDeTrouverPIapres=1 ; return PI;}
+
+
+<INITIAL,HORSBALISE>{newline}*"<"		    { BEGIN(DANSBALISE); return INFCAR;}
+
+
+<DANSBALISE>">"			{ BEGIN(HORSBALISE);return SUPCAR;}
+
+
+<DANSBALISE>"/"		{return SLASH;}
+
+
+<DANSBALISE>{egalevolue}			{return Eq;}
+
+
+<DANSBALISE>{Name}			{srlval.chaine=strdup(yytext);return ID;}
+
+
+<DANSBALISE>{attvalue}		{return ATTVALUE;}
 
 
@@ -215,5 +215,5 @@
 
 
-<INITIAL,DANSBALISE,HORSBALISE>.|\n	{if (affichetrace==1) fprintf(stderr,"error : ligne %d : caractere non reconnu '%s'\n",srlineno,yytext);}
+<INITIAL,DANSBALISE,HORSBALISE>.|\n	{fprintf(stderr,"error : ligne %d : caractere non reconnu '%s'\n",srlineno,yytext);}
 
 %%
